import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Cantor extends PApplet {

public void setup() 
{
  background(255);
  size(1400, 500);
  noStroke();
  smooth();
  fill(255,0,0);
  noLoop();
}

int order=0, x=25, y=200, h=100, l=1350;

public void draw() 
  {
     background(255);
     drawCantor(order,x,y,h,l);
  }

public void drawCantor(int order, int x, int y, int h, int l)
  {
    if (order == 0)
      drawStrip(x,y,h,l);  
    else
      {
        l=round(l/3.0f);
        drawCantor(order-1,x,y,h,l);
        drawCantor(order-1,x+2*l,y,h,l);
      }
   }

public void drawStrip(int x, int y, int h, int l)
  {
    quad(x,y,x,y+h,x+l,y+h,x+l,y);
    
  }
  
  public void mousePressed() 
  {
    redraw();
    order++;
    if (order==8)
      order=0;
  }
  
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ECE9D8", "Cantor" });
  }
}
